using FitConnect;
using FitConnect.Models;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;

namespace DemoRunner;

public static class SenderDemo {
    public static void Run(IConfigurationRoot config, ILogger logger) {
        var clientId = config["FitConnect:Sender:ClientId"];
        var clientSecret = config["FitConnect:Sender:ClientSecret"];
        var destinationId = config["FitConnect:Sender:DestinationId"];
        var leikaKey = config["FitConnect:Sender:LeikaKey"];


        OutputHelper.PrintSender();
        var submission = new Sender(FitConnectEnvironment.Development, clientId, clientSecret, logger)
            .WithDestination(destinationId)
            .WithServiceType("FIT Connect Demo", leikaKey)
            .WithAttachments(new[] { new Attachment("Test.pdf", "Test Attachment") })
            .WithData("{\"message\":\"Hello World\"}")
            .Submit();
    }
} 