using FitConnect.Services.Models.v1;
using Microsoft.Extensions.Logging;

namespace FitConnect.Services;

public class DestinationService : RestCallService, IDestinationService {
    private const string ApiVersion = "v1";
    private readonly IOAuthService _oAuthService;

    public DestinationService(string baseUrl, IOAuthService oAuthService, string version = "v1",
        ILogger? logger = null) : base(
        $"{baseUrl}/{version}", logger) {
        _oAuthService = oAuthService;
    }

    /// <summary>
    ///     <para>@PostMapping("/destinations")</para>
    /// </summary>
    /// <param name="createDestination">RequestBody</param>
    /// <returns></returns>
    /// <exception cref="NotImplementedException"></exception>
    public PrivateDestinationDto CreateDestination(CreateDestinationDto createDestination) {
        throw new NotImplementedException();
    }


    /// <summary>
    ///     <para>@GetMapping("/destinations/{destinationId}")</para>
    /// </summary>
    /// <param name="destinationId">PathVariable</param>
    /// <exception cref="NotImplementedException"></exception>
    public void GetDestination(string destinationId) {
        throw new NotImplementedException();
    }


    /// <summary>
    ///     <para>@DeleteMapping("/destinations/{destinationId}")</para>
    /// </summary>
    /// <param name="destinationId">PathVariable</param>
    /// <returns></returns>
    /// <exception cref="NotImplementedException"></exception>
    public bool DeleteDestination(string destinationId) {
        throw new NotImplementedException();
    }


    /// <summary>
    ///     <para>@PatchMapping("/destinations/{destinationId}")</para>
    /// </summary>
    /// <param name="destinationId">PathVariable</param>
    /// <param name="patchDestination">RequestBody</param>
    /// <returns></returns>
    /// <exception cref="NotImplementedException"></exception>
    public PrivateDestinationDto PatchDestination(string destinationId,
        PatchDestinationDto patchDestination) {
        throw new NotImplementedException();
    }


    /// <summary>
    ///     <para>@GetMapping("/destinations")</para>
    /// </summary>
    /// <param name="offset">RequestParam</param>
    /// <param name="limit">RequestParam</param>
    /// <returns></returns>
    /// <exception cref="NotImplementedException"></exception>
    public DestinationListDto ListDestinations(int offset, int limit) {
        throw new NotImplementedException();
    }


    /// <summary>
    ///     <para>@PutMapping("/destinations/{destinationId}")</para>
    /// </summary>
    /// <param name="destinationId">PathVariable</param>
    /// <param name="updateDestination">RequestBody</param>
    /// <returns></returns>
    /// <exception cref="NotImplementedException"></exception>
    public PrivateDestinationDto UpdateDestination(string destinationId,
        UpdateDestinationDto updateDestination) {
        throw new NotImplementedException();
    }

    public async Task<string> GetPublicKey(string destinationId) {
        _oAuthService.EnsureAuthenticated();
        var destinationInfo =
            await RestCall<PublicDestinationDto>($"/destinations/{destinationId}",
                HttpMethod.Get);

        if (destinationInfo?.EncryptionKid == null)
            throw new ArgumentException("EncryptionKid was not received");

        var keyId = destinationInfo.EncryptionKid;

        // /v1/destinations/{{destinationId}}/keys/{{keyId}
        var result = await RestCallForString($"/destinations/{destinationId}/keys/{keyId}",
            HttpMethod.Get);

        return result;
    }
}
