using Microsoft.Extensions.Logging;

namespace FitConnect.Services;

public class RouteService : RestCallService, IRouteService {
    private readonly IOAuthService _oAuthService;

    public RouteService(string baseUrl, IOAuthService oAuthService, string version = "v1",
        ILogger? logger = null) : base($"{baseUrl}/{version}", logger) {
        _oAuthService = oAuthService;
    }

    /// <summary>
    ///     Returns the destination id for the given intent.
    /// </summary>
    /// <param name="leiaKey"></param>
    /// <param name="ags"></param>
    /// <param name="ars"></param>
    /// <param name="areaId"></param>
    /// <returns></returns>
    /// <exception cref="NotImplementedException"></exception>
    public async Task<string> GetDestinationIdAsync(string leiaKey, string? ags, string? ars,
        string? areaId) {
        throw new NotImplementedException();
    }
}
